﻿Imports System
Imports System.Collections.Generic
Imports System.Web
Imports System.Web.UI
Imports System.Web.UI.WebControls
Imports System.Data
Imports Infragistics.WebUI.UltraWebGrid
Imports Infragistics.Web.UI

Partial Public Class WebForm3
    Inherits System.Web.UI.Page
    Private p_DS As DataSet

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        If Not IsPostBack Then
            UltraWebGrid1.DataSource = GetData()
            UltraWebGrid1.DataBind()


            Dim t As Infragistics.WebUI.UltraWebGrid.TemplatedColumn = TryCast(Me.UltraWebGrid1.Columns.FromKey("CurrentValues"), Infragistics.WebUI.UltraWebGrid.TemplatedColumn)
            Dim ci As Infragistics.WebUI.UltraWebGrid.CellItem
            '' Loop through all the rows.. find out WHICH fieldtype we are using then make appropriate control visible and assign value
            '************************************************


            For Each r As UltraGridRow In UltraWebGrid1.Rows
                ci = t.CellItems(r.Index)
                If r.Cells.FromKey("ParameterType").Value.ToString.Contains("Date") Then

                    Dim DT As Infragistics.WebUI.WebDataInput.WebDateTimeEdit = DirectCast(ci.FindControl("WebDateTimeEdit1"), Infragistics.WebUI.WebDataInput.WebDateTimeEdit)
                    DT.EditModeFormat = "g"
                    DT.DisplayModeFormat = "g"
                    DT.DataMode = Infragistics.WebUI.WebDataInput.DateDataMode.Text
                    DT.Value = r.Cells.FromKey("CurrentValues").Value

                    DT.Visible = True
                ElseIf r.Cells.FromKey("ParameterType").Value.ToString.Contains("Integer") Then
                    Dim b As Infragistics.WebUI.WebDataInput.WebTextEdit = DirectCast(ci.FindControl("WebTextEdit1"), Infragistics.WebUI.WebDataInput.WebTextEdit)
                    b.Value = r.Cells.FromKey("CurrentValues").Value
                    b.Visible = True
                Else
                    Dim dd As DropDownList = DirectCast(ci.FindControl("DropDownList1"), DropDownList)
                    dd.SelectedValue = r.Cells.FromKey("CurrentValues").Value
                    dd.Visible = True
                End If
            Next
        End If
    End Sub

    Private Function GetData() As DataSet
        Dim result As New DataSet

        result = New DataSet
        result.Tables.Add("ReportParameters")
        With result.Tables(0).Columns
            .Add("PromptText")
            .Add("MinimumValue")
            .Add("MaximumValue")
            .Add("ParameterFieldName")
            .Add("ParameterType")
            .Add("CurrentValues")
        End With
        Dim row As DataRow



        row = result.Tables(0).NewRow()

        row("PromptText") = "Enter a Profile ID"
        row("MinimumValue") = 1
        row("MaximumValue") = 99
        row("ParameterFieldName") = "profileid"
        row("ParameterType") = "Integer"
        row("CurrentValues") = 1
        result.Tables(0).Rows.Add(row)
        row = result.Tables(0).NewRow()
        row("PromptText") = "Enter a Start Date"
        row("MinimumValue") = ""
        row("MaximumValue") = ""
        row("ParameterFieldName") = "startdate"
        row("ParameterType") = "DateTime"
        row("CurrentValues") = DateAdd(DateInterval.Day, -7, GetDate(False))
        result.Tables(0).Rows.Add(row)
        row = result.Tables(0).NewRow()
        row("PromptText") = "Enter a End Date"
        row("MinimumValue") = ""
        row("MaximumValue") = ""
        row("ParameterFieldName") = "enddate"
        row("ParameterType") = "DateTime"
        row("CurrentValues") = GetDate(True)
        result.Tables(0).Rows.Add(row)



        Return result
    End Function

    Protected Sub Button1_Click(ByVal sender As Object, ByVal e As EventArgs) Handles Button1.Click


        'this part now works

        For Each r As UltraGridRow In UltraWebGrid1.Rows
            Dim t As Infragistics.WebUI.UltraWebGrid.TemplatedColumn = TryCast(Me.UltraWebGrid1.Columns.FromKey("CurrentValues"), Infragistics.WebUI.UltraWebGrid.TemplatedColumn)
            Dim ci As Infragistics.WebUI.UltraWebGrid.CellItem = t.CellItems(r.Index)


            If r.Cells.FromKey("ParameterType").Value.ToString.Contains("Date") Then

                Dim DT As Infragistics.WebUI.WebDataInput.WebDateTimeEdit = DirectCast(ci.FindControl("WebDateTimeEdit1"), Infragistics.WebUI.WebDataInput.WebDateTimeEdit)
                r.Cells.FromKey("CurrentValues").Value = DT.Value

            Else
                Dim b As Infragistics.WebUI.WebDataInput.WebTextEdit = DirectCast(ci.FindControl("WebTextEdit1"), Infragistics.WebUI.WebDataInput.WebTextEdit)
                r.Cells.FromKey("CurrentValues").Value = b.Value

            End If
        Next





        Dim result = New DataSet
        result.Tables.Add("ReportParameters")
        With result.Tables(0).Columns
            .Add("PromptText")
            .Add("MinimumValue")
            .Add("MaximumValue")
            .Add("ParameterFieldName")
            .Add("ParameterType")
            .Add("CurrentValues")
        End With
        Dim r1 As Infragistics.WebUI.UltraWebGrid.UltraGridRow
        Dim dr As DataRow
        Dim counter As Integer = 0
        For Each r1 In UltraWebGrid1.Rows
            dr = result.Tables(0).NewRow
            dr(0) = r1.Cells.FromKey("PromptText").Value
            dr(1) = r1.Cells.FromKey("MinimumValue").Value
            dr(2) = r1.Cells.FromKey("MaximumValue").Value
            dr(3) = r1.Cells.FromKey("ParameterFieldName").Value
            dr(4) = r1.Cells.FromKey("ParameterType").Value
            dr(5) = r1.Cells.FromKey("CurrentValues").Value
            result.Tables(0).Rows.Add(dr)
            counter += 1
        Next
        p_DS = result
    End Sub

    Public Function GetDate(ByVal bEOD As Boolean) As DateTime
        Dim dt As DateTime = Now
        If bEOD Then 'end of day.. means date at 23.59.59
            GetDate = (New DateTime(dt.Year, dt.Month, dt.Day, 23, 59, 59))
        Else ' means time of 00.01.01
            GetDate = (New DateTime(dt.Year, dt.Month, dt.Day, 0, 0, 0))
        End If
    End Function

End Class

